[19.04 FEAT] Valgrind z13 support

Bug #1799696 reported by bugproxy on 2018-10-24
16
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Ubuntu on IBM z Systems
High
Canonical Foundations Team
valgrind (Ubuntu)
Undecided
Skipper Bug Screeners

Bug Description

Function:
Provide support for the instructions introduced with IBM z13, e.g. SIMD in the Valgrind debugging infrastructure.

Available with valgrind 3.14.0 + 2 patch2

Addl.
- floating point vector support (https://bugs.kde.org/show_bug.cgi?id=385411)
- gdb server intergration support (https://bugs.kde.org/show_bug.cgi?id=397187).
need to be applied , which is upstream committed for 3.15
completing this item

bugproxy (bugproxy) on 2018-10-24
tags: added: architecture-s39064 bugnameltc-163659 severity-high targetmilestone-inin1904
Changed in ubuntu:
assignee: nobody → Skipper Bug Screeners (skipper-screen-team)
affects: ubuntu → valgrind (Ubuntu)
Changed in ubuntu-z-systems:
importance: Undecided → High
status: New → Triaged
Changed in ubuntu-z-systems:
assignee: nobody → Canonical Foundations Team (canonical-foundations)
information type: Private → Public
Changed in valgrind (Ubuntu):
status: New → Confirmed
Dimitri John Ledkov (xnox) wrote :

In v3.15.0 in master I see following s390x bugfixes staged:

400490 s390x: VRs allocated as if separate from FPRs
400491 s390x: Operand of LOCH treated as unsigned integer
397187 z13 vector register support for vgdb gdbserver
401277 More bugs in z13 support

However, https://bugs.kde.org/show_bug.cgi?id=385411 is not in yet? Or is the NEWS out of date?

Changed in ubuntu-z-systems:
status: Triaged → Confirmed
tags: added: id-5bdcbcdb52b9b536864c4043

------- Comment From <email address hidden> 2018-11-28 11:11 EDT-------
(In reply to comment #8)
> In v3.15.0 in master I see following s390x bugfixes staged:
>
> 400490 s390x: VRs allocated as if separate from FPRs
> 400491 s390x: Operand of LOCH treated as unsigned integer
> 397187 z13 vector register support for vgdb gdbserver
> 401277 More bugs in z13 support
>
> However, https://bugs.kde.org/show_bug.cgi?id=385411 is not in yet? Or is
> the NEWS out of date?

Correct. The vector floating point support is not upstream yet. But the patch has already been reviewed by Julian and will be committed any time soon.

bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2018-11-30 09:23 EDT-------
(In reply to comment #10)
> Correct. The vector floating point support is not upstream yet. But the
> patch has already been reviewed by Julian and will be committed any time
> soon.
The vector FP support is upstream now.

Changed in valgrind (Ubuntu):
status: Confirmed → Fix Committed
Dimitri John Ledkov (xnox) wrote :

A basic valgrind trace does not appear to be working in qemu-kvm VM anymore in disco-proposed:

autopkgtest [00:46:19]: test command1: valgrind /bin/true
autopkgtest [00:46:19]: test command1: [-----------------------
==1206== Memcheck, a memory error detector
==1206== Copyright (C) 2002-2017, and GNU GPL'd, by Julian Seward et al.
==1206== Using Valgrind-3.14.0 and LibVEX; rerun with -h for copyright info
==1206== Command: /bin/true
==1206==
==1206== Emulation fatal error -- Valgrind cannot continue:
==1206== Encountered an instruction that requires the vector facility.
==1206== That facility is not available on this host
==1206== at 0x4015980: _dl_runtime_resolve_vx (dl-trampoline.h:82)
==1206== by 0x482960D: ??? (in /usr/lib/s390x-linux-gnu/valgrind/vgpreload_core-s390x-linux.so)
==1206==
==1206== Valgrind has to exit now. Sorry.
==1206==

I will check the cpu settings that we use in these VMs, and/or if anything needs to be adjusted on the LPARs. Ideally I was expecting /bin/true, and valgrind /bin/true to just work on zEC12 and up; with or without vector instructions in Qemu KVM.

------- Comment on attachment From <email address hidden> 2019-01-21 08:27 EDT-------

> ==1206== Encountered an instruction that requires the vector facility.
> ==1206== That facility is not available on this host
The attached patch hopefully fixes this. Can you please verify that?

Changed in ubuntu-z-systems:
status: Confirmed → In Progress
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package valgrind - 1:3.14.0-2ubuntu4

---------------
valgrind (1:3.14.0-2ubuntu4) disco; urgency=medium

  * s390x Fix vector facility bit.

valgrind (1:3.14.0-2ubuntu3) disco; urgency=medium

  * Cherrypick s390x/z13 fixes from valgrind master (3.15) LP: #1799696

valgrind (1:3.14.0-2ubuntu2) disco; urgency=medium

  * debian/patches/usrmerge_support.patch: make valgrind aware of usrmerge;
    if we can't find the debug files under the full objpath (including /usr),
    also try the alternative path by stripping out /usr. (LP: #1808508)

valgrind (1:3.14.0-2ubuntu1) disco; urgency=medium

  * Merge with Debian; remaining changes:
    - Lower over-inflated valgrind-dbg Recommends to Suggests instead.
    - Don't strip vgpreload* on ARM; this results in unusable stack traces
      without valgrind-dbg.
    - Configure with --enable-only64bit on AArch64.
    - Enable parallel builds.

valgrind (1:3.14.0-2) unstable; urgency=medium

  * Fix path in dh_shlibdeps argument on non-x86 arches (Closes: #913822)

valgrind (1:3.14.0-1) unstable; urgency=medium

  * New upstream release (Closes: #913208)
    + Fix assertion `cfsi_fits` failing in simple C program (Closes: #909797)
  * Drop patches backported from upstream
  * Refresh patches
  * Bump Standards-Version to 4.2.1 (no changes needed)
  * Bump debhelper compat level to 11
  * Update install paths
  * Use pkg-config to detect MPI to fix cross-build.
    Thanks to Helmut Grohne for the patch (Closes: #902297)

 -- Dimitri John Ledkov <email address hidden> Mon, 21 Jan 2019 17:13:06 +0000

Changed in valgrind (Ubuntu):
status: Fix Committed → Fix Released
Changed in ubuntu-z-systems:
status: In Progress → Fix Released

------- Comment From <email address hidden> 2019-02-05 02:39 EDT-------
IBM Bugzilla status -> closed, Fix Released with Disco

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.